"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var abstract_dao_1 = require("./abstract-dao");
var _ = require("lodash");
var model_1 = require("../model");
var VmwareDatastoreDao = (function (_super) {
    __extends(VmwareDatastoreDao, _super);
    function VmwareDatastoreDao() {
        return _super.call(this, model_1.Model.VmwareDatastore) || this;
    }
    VmwareDatastoreDao.prototype.listDatastoresOnPeer = function (peer) {
        var _this = this;
        var results = [];
        return this.middlewareClient.callRpcMethod('vmware.get_datastores', [
            peer.credentials.address,
            peer.credentials.username,
            peer.credentials.password.$password,
            false
        ]).then(function (response) {
            results = response.args.fragment;
            return _.forEach(_this.handleNextFragment(response.id, response.args.seqno, results), function (result) { return result._objectType = 'VmwareDatastore'; });
        });
    };
    VmwareDatastoreDao.prototype.handleNextFragment = function (streamId, seqno, results) {
        var _this = this;
        this.middlewareClient.continueRpcMethod(streamId, seqno).then(function (response) {
            if (response.args.fragment) {
                results = results.concat(response.args.fragment);
                results = _this.handleNextFragment(response.id, response.args.seqno, results);
            }
        });
        return results;
    };
    return VmwareDatastoreDao;
}(abstract_dao_1.AbstractDao));
exports.VmwareDatastoreDao = VmwareDatastoreDao;
