"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var abstract_dao_1 = require("./abstract-dao");
var Volume_1 = require("../model/Volume");
var VolumeDao = (function (_super) {
    __extends(VolumeDao, _super);
    function VolumeDao() {
        return _super.call(this, Volume_1.Volume.getClassName()) || this;
    }
    VolumeDao.prototype.getDisksAllocation = function (diskIds) {
        return this.middlewareClient.callRpcMethod('volume.get_disks_allocation', [diskIds]);
    };
    VolumeDao.prototype.getAvailableDisks = function () {
        return this.middlewareClient.callRpcMethod('volume.get_available_disks');
    };
    VolumeDao.prototype.export = function (volume) {
        return this.middlewareClient.submitTask('volume.export', [volume.id]);
    };
    VolumeDao.prototype.lock = function (volume) {
        return this.middlewareClient.submitTask('volume.lock', [volume.id]);
    };
    VolumeDao.prototype.unlock = function (volume, password) {
        return this.middlewareClient.submitTask('volume.unlock', [volume.id, password]);
    };
    VolumeDao.prototype.rekey = function (volume, key, password) {
        return this.middlewareClient.submitTask('volume.rekey', [volume.id, !!key, password]);
    };
    VolumeDao.prototype.getVolumeKey = function (volume) {
        return this.middlewareClient.submitTaskWithDownload('volume.keys.backup', [volume.id, 'key_' + volume.id]);
    };
    VolumeDao.prototype.importEncrypted = function (name, disks, key, password) {
        return this.middlewareClient.submitTask('volume.import', [
            name,
            name,
            {},
            {
                key: key,
                disks: disks.map(function (x) { return x.path; })
            },
            password
        ]);
    };
    VolumeDao.prototype.scrub = function (volume) {
        return this.middlewareClient.submitTask('volume.scrub', [volume.id]);
    };
    VolumeDao.prototype.upgrade = function (volume) {
        return this.middlewareClient.submitTask('volume.upgrade', [volume.id]);
    };
    VolumeDao.prototype.findMedia = function () {
        return this.middlewareClient.callRpcMethod('volume.find_media');
    };
    VolumeDao.prototype.importDisk = function (disk, path, fsType) {
        return this.middlewareClient.submitTask('volume.import_disk', [disk, path, fsType]);
    };
    VolumeDao.prototype.offlineVdev = function (volumeId, vdev) {
        return this.middlewareClient.submitTask('zfs.pool.offline_disk', [volumeId, vdev.guid]);
    };
    VolumeDao.prototype.onlineVdev = function (volumeId, vdev) {
        return this.middlewareClient.submitTask('zfs.pool.online_disk', [volumeId, vdev.guid]);
    };
    VolumeDao.prototype.importShares = function (volumeId) {
        return this.middlewareClient.submitTask('volume.autoimport', [volumeId, 'shares']);
    };
    return VolumeDao;
}(abstract_dao_1.AbstractDao));
exports.VolumeDao = VolumeDao;
