"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var immutable = require("immutable");
var _ = require("lodash");
function importObjects(previousState, action) {
    var type = action.meta.type, idPath = action.meta.idPath, typeState = previousState.has(type) ? previousState.get(type) : immutable.Map();
    for (var _i = 0, _a = action.payload; _i < _a.length; _i++) {
        var object = _a[_i];
        var id = _.get(object, idPath);
        typeState = typeState.set(id, immutable.fromJS(object)
            .set('_stableId', id)
            .set('_objectType', type));
    }
    return previousState.set(type, typeState);
}
exports.importObjects = importObjects;
