"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var alert_filter_dao_1 = require("../dao/alert-filter-dao");
var _ = require("lodash");
var abstract_model_repository_1 = require("./abstract-model-repository");
var AlertFilterRepository = (function (_super) {
    __extends(AlertFilterRepository, _super);
    function AlertFilterRepository(alertFilterDao) {
        var _this = _super.call(this, alertFilterDao) || this;
        _this.alertFilterDao = alertFilterDao;
        return _this;
    }
    AlertFilterRepository.getInstance = function () {
        if (!AlertFilterRepository.instance) {
            AlertFilterRepository.instance = new AlertFilterRepository(new alert_filter_dao_1.AlertFilterDao());
        }
        return AlertFilterRepository.instance;
    };
    AlertFilterRepository.prototype.getNewAlertFilter = function () {
        return this.getNewInstance()
            .then(function (alertFilter) { return _.assign(alertFilter, { predicates: [] }); });
    };
    AlertFilterRepository.prototype.listAlertFilters = function () {
        return this.list();
    };
    AlertFilterRepository.prototype.save = function (alertFilter) {
        delete alertFilter.parameters.addresses;
        return _super.prototype.save.call(this, alertFilter);
    };
    return AlertFilterRepository;
}(abstract_model_repository_1.AbstractModelRepository));
exports.AlertFilterRepository = AlertFilterRepository;
