"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var abstract_model_repository_1 = require("./abstract-model-repository");
var docker_collection_dao_1 = require("../dao/docker-collection-dao");
var _ = require("lodash");
var DockerCollectionRepository = (function (_super) {
    __extends(DockerCollectionRepository, _super);
    function DockerCollectionRepository(dockerCollectionDao) {
        var _this = _super.call(this, dockerCollectionDao) || this;
        _this.dockerCollectionDao = dockerCollectionDao;
        return _this;
    }
    DockerCollectionRepository.getInstance = function () {
        if (!DockerCollectionRepository.instance) {
            DockerCollectionRepository.instance = new DockerCollectionRepository(new docker_collection_dao_1.DockerCollectionDao());
        }
        return DockerCollectionRepository.instance;
    };
    DockerCollectionRepository.prototype.getNewDockerCollection = function () {
        return this.dockerCollectionDao.getNewInstance();
    };
    DockerCollectionRepository.prototype.getDockerImagesWithCollection = function (collection) {
        return this.dockerCollectionDao.getImages(collection).then(function (templates) {
            return _.filter(templates, function (template) {
                return _.startsWith(template.name, collection.collection) ? template : false;
            });
        });
    };
    DockerCollectionRepository.prototype.listDockerCollections = function () {
        return this.dockerCollectionDao.list();
    };
    return DockerCollectionRepository;
}(abstract_model_repository_1.AbstractModelRepository));
exports.DockerCollectionRepository = DockerCollectionRepository;
