"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var abstract_model_repository_1 = require("./abstract-model-repository");
var docker_host_dao_1 = require("../dao/docker-host-dao");
var DockerHostRepository = (function (_super) {
    __extends(DockerHostRepository, _super);
    function DockerHostRepository(dockerHostDao) {
        var _this = _super.call(this, dockerHostDao) || this;
        _this.dockerHostDao = dockerHostDao;
        return _this;
    }
    DockerHostRepository.getInstance = function () {
        if (!DockerHostRepository.instance) {
            DockerHostRepository.instance = new DockerHostRepository(new docker_host_dao_1.DockerHostDao());
        }
        return DockerHostRepository.instance;
    };
    DockerHostRepository.prototype.listDockerHosts = function () {
        return this.dockerHostDao.list();
    };
    DockerHostRepository.prototype.getNewDockerHost = function () {
        return this.dockerHostDao.getNewInstance();
    };
    return DockerHostRepository;
}(abstract_model_repository_1.AbstractModelRepository));
exports.DockerHostRepository = DockerHostRepository;
