"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var alert_emitter_email_dao_1 = require("../dao/alert-emitter-email-dao");
var MailRepository = (function () {
    function MailRepository(alertEmitterEmailDao) {
        this.alertEmitterEmailDao = alertEmitterEmailDao;
    }
    MailRepository.getInstance = function () {
        if (!MailRepository.instance) {
            MailRepository.instance = new MailRepository(new alert_emitter_email_dao_1.AlertEmitterEmailDao());
        }
        return MailRepository.instance;
    };
    MailRepository.prototype.getConfig = function () {
        return this.alertEmitterEmailDao.get();
    };
    MailRepository.prototype.saveConfig = function (config) {
        return this.alertEmitterEmailDao.save(config);
    };
    MailRepository.prototype.sendTestMail = function (mailMessage) {
        return this.alertEmitterEmailDao.send(mailMessage);
    };
    return MailRepository;
}());
exports.MailRepository = MailRepository;
