"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var abstract_repository_1 = require("./abstract-repository");
var section_dao_1 = require("../dao/section-dao");
var section_settings_dao_1 = require("../dao/section-settings-dao");
var _ = require("lodash");
var SectionRepository = (function (_super) {
    __extends(SectionRepository, _super);
    function SectionRepository(sectionDao, sectionSettingsDao) {
        var _this = _super.call(this) || this;
        _this.sectionDao = sectionDao;
        _this.sectionSettingsDao = sectionSettingsDao;
        return _this;
    }
    SectionRepository.getInstance = function () {
        if (!SectionRepository.instance) {
            SectionRepository.instance = new SectionRepository(new section_dao_1.SectionDao(), new section_settings_dao_1.SectionSettingsDao());
        }
        return SectionRepository.instance;
    };
    SectionRepository.prototype.getNewSection = function () {
        return this.sectionDao.getNewInstance().then(function (section) { return _.assign(section, { _isNew: false }); });
    };
    SectionRepository.prototype.getNewSectionSettings = function () {
        return this.sectionSettingsDao.getNewInstance().then(function (section) { return _.assign(section, { _isNew: false }); });
    };
    SectionRepository.prototype.handleStateChange = function (name, state) {
    };
    SectionRepository.prototype.handleEvent = function (name, data) {
    };
    return SectionRepository;
}(abstract_repository_1.AbstractRepository));
exports.SectionRepository = SectionRepository;
