"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var event_dispatcher_service_1 = require("./event-dispatcher-service");
var Events_1 = require("../Events");
var account_repository_1 = require("../repository/account-repository");
var SessionService = (function () {
    function SessionService(eventDispatcherService, userRepository) {
        if (eventDispatcherService === void 0) { eventDispatcherService = event_dispatcher_service_1.EventDispatcherService.getInstance(); }
        if (userRepository === void 0) { userRepository = account_repository_1.AccountRepository.getInstance(); }
        this.eventDispatcherService = eventDispatcherService;
        this.userRepository = userRepository;
        this.eventDispatcherService.addEventListener(Events_1.Events.userLoggedIn, this.handleUserLoggedIn.bind(this));
    }
    SessionService.getInstance = function () {
        if (!SessionService.instance) {
            SessionService.instance = new SessionService();
        }
        return SessionService.instance;
    };
    Object.defineProperty(SessionService.prototype, "session", {
        get: function () {
            return this.openedSession;
        },
        enumerable: true,
        configurable: true
    });
    SessionService.prototype.handleUserLoggedIn = function (loginInfo) {
        var _this = this;
        this.openedSession = {
            url: loginInfo.url
        };
        this.userRepository.findUserWithName(loginInfo.username).then(function (user) {
            _this.openedSession.user = user;
            _this.eventDispatcherService.dispatch(Events_1.Events.sessionOpened, _this.openedSession);
        });
    };
    return SessionService;
}());
exports.SessionService = SessionService;
