"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var DataObjectChangeService = (function () {
    function DataObjectChangeService() {
    }
    DataObjectChangeService.prototype.handleDataChange = function (uiObjects, state, objectType, options) {
        if (_.isObject(objectType)) {
            options = objectType;
            objectType = null;
        }
        options = options || {};
        var newObjects = _.sortBy(_.filter(state.valueSeq().toJS(), options.filter || _.identity), options.sort || 'id');
        if (!uiObjects) {
            uiObjects = newObjects;
        }
        else {
            _.forEach(newObjects, function (newObject) {
                var uiObject = _.find(uiObjects, { id: newObject.id });
                if (uiObject) {
                    Object.assign(uiObject, newObject);
                }
                else {
                    uiObjects.splice(_.sortedIndexBy(uiObjects, newObject, options.sort || 'id'), 0, newObject);
                }
            });
            _.forEachRight(uiObjects, function (uiObject) {
                if (!state.has(uiObject.id) && (!objectType || objectType === uiObject._objectType)) {
                    uiObjects.splice(_.indexOf(uiObjects, uiObject), 1);
                }
            });
        }
        return uiObjects;
    };
    DataObjectChangeService.prototype.handleContentChange = function (uiObjects, state, objectType, options) {
        if (_.isObject(objectType)) {
            options = objectType;
            objectType = null;
        }
        options = options || {};
        var newObjects = _.sortBy(_.filter(state.valueSeq().toJS(), options.filter || _.identity), options.sort || 'id');
        if (!uiObjects) {
            uiObjects = newObjects;
        }
        else {
            _.forEach(newObjects, function (newObject) {
                var uiObject = _.find(uiObjects, { id: newObject.id });
                if (!uiObject) {
                    uiObjects.splice(_.sortedIndexBy(uiObjects, newObject, options.sort || 'id'), 0, newObject);
                }
            });
            _.forEachRight(uiObjects, function (uiObject) {
                if (!state.has(uiObject.id) && (!objectType || objectType === uiObject._objectType)) {
                    uiObjects.splice(_.indexOf(uiObjects, uiObject), 1);
                }
            });
        }
        return uiObjects;
    };
    return DataObjectChangeService;
}());
exports.DataObjectChangeService = DataObjectChangeService;
