/// <reference types="d3" />
/**
 * Copyright 2017-present Palantir Technologies, Inc. All rights reserved.
 * Licensed under the MIT License (the "License"); you may obtain a copy of the
 * license at https://github.com/palantir/svg-typewriter/blob/develop/LICENSE
 */
import * as d3 from "d3";
export declare class BaseAnimator {
    /**
     * The default duration of the animation in milliseconds
     */
    static DEFAULT_DURATION_MILLISECONDS: number;
    /**
     * The default easing of the animation
     */
    static DEFAULT_EASING: string;
    private _duration;
    private _delay;
    private _easing;
    private _moveX;
    private _moveY;
    constructor();
    animate(selection: d3.Selection<any>): any;
    _animate(selection: d3.Selection<any>, attr: any): d3.Transition<any>;
    duration(): number;
    duration(duration: number): BaseAnimator;
    moveX(): number;
    moveX(shift: number): BaseAnimator;
    moveY(): number;
    moveY(shift: number): BaseAnimator;
    delay(): number;
    delay(delay: number): BaseAnimator;
    easing(): string;
    easing(easing: string): BaseAnimator;
}
