/// <reference types="d3" />
/**
 * Copyright 2017-present Palantir Technologies, Inc. All rights reserved.
 * Licensed under the MIT License (the "License"); you may obtain a copy of the
 * license at https://github.com/palantir/svg-typewriter/blob/develop/LICENSE
 */
import * as d3 from "d3";
/**
 * Dimension of area's BBox.
 */
export interface IDimensions {
    width: number;
    height: number;
}
export declare class AbstractMeasurer {
    static HEIGHT_TEXT: string;
    private textMeasurer;
    constructor(area: d3.Selection<void>, className?: string);
    measure(text?: string): IDimensions;
    private checkSelectionIsText(d);
    private getTextMeasurer(area, className);
    private measureBBox(d, text);
}
