/// <reference types="d3" />
/**
 * Copyright 2017-present Palantir Technologies, Inc. All rights reserved.
 * Licensed under the MIT License (the "License"); you may obtain a copy of the
 * license at https://github.com/palantir/svg-typewriter/blob/develop/LICENSE
 */
import * as d3 from "d3";
import { AbstractMeasurer, IDimensions } from "./abstractMeasurer";
export declare class Measurer extends AbstractMeasurer {
    private guardWidth;
    private useGuards;
    constructor(area: d3.Selection<void>, className?: string, useGuards?: boolean);
    _addGuards(text: string): string;
    _measureLine(line: string, forceGuards?: boolean): IDimensions;
    measure(text?: string): IDimensions;
    private getGuardWidth();
}
